define("qtype_proforma/FileViewer",["exports","./MoodleSyncer","./codemirror-global","./codemirror","./clike","./python","./javascriptmode","./xml","./matchbrackets","./closebrackets","./active-line","core/str","core/modal_factory","core/modal_events"],(function(_exports,_MoodleSyncer,_codemirrorGlobal,_codemirror,_clike,_python,_javascriptmode,_xml,_matchbrackets,_closebrackets,_activeLine,Str,_modal_factory,_modal_events){function _getRequireWildcardCache(nodeInterop){if("function"!=typeof WeakMap)return null;var cacheBabelInterop=new WeakMap,cacheNodeInterop=new WeakMap;return(_getRequireWildcardCache=function(nodeInterop){return nodeInterop?cacheNodeInterop:cacheBabelInterop})(nodeInterop)}function _interopRequireDefault(obj){return obj&&obj.__esModule?obj:{default:obj}}function _defineProperty(obj,key,value){return key in obj?Object.defineProperty(obj,key,{value:value,enumerable:!0,configurable:!0,writable:!0}):obj[key]=value,obj}
/**
   * The ProFormA Question CodeMirror support functions
   *
   * @package    qtype
   * @subpackage proforma
   * @copyright  2022 Ostfalia Hochschule fuer angewandte Wissenschaften
   * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
   * @author     K.Borm <k.borm[at]ostfalia.de>
   */Object.defineProperty(_exports,"__esModule",{value:!0}),_exports.RootNode=_exports.Framework=_exports.FolderNode=_exports.FileNode=void 0,_codemirror=_interopRequireDefault(_codemirror),Str=function(obj,nodeInterop){if(!nodeInterop&&obj&&obj.__esModule)return obj;if(null===obj||"object"!=typeof obj&&"function"!=typeof obj)return{default:obj};var cache=_getRequireWildcardCache(nodeInterop);if(cache&&cache.has(obj))return cache.get(obj);var newObj={},hasPropertyDescriptor=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(var key in obj)if("default"!==key&&Object.prototype.hasOwnProperty.call(obj,key)){var desc=hasPropertyDescriptor?Object.getOwnPropertyDescriptor(obj,key):null;desc&&(desc.get||desc.set)?Object.defineProperty(newObj,key,desc):newObj[key]=obj[key]}newObj.default=obj,cache&&cache.set(obj,newObj);return newObj}(Str),_modal_factory=_interopRequireDefault(_modal_factory),_modal_events=_interopRequireDefault(_modal_events);let autosaveIntervall=-1;function modalPrompt(titleId,labelId,defaultValue,callback){let stringsPromise=Str.get_strings([{key:titleId,component:"qtype_proforma"},{key:labelId,component:"qtype_proforma"}]),modalPromise=_modal_factory.default.create({type:_modal_factory.default.types.SAVE_CANCEL});Promise.all([stringsPromise,modalPromise]).then((_ref=>{let[strings,modal]=_ref;modal.setTitle(strings[0]),modal.setSaveButtonText("Ok"),modal.setBody(strings[1]+'<input type="text" name="promptname" value="'+defaultValue+'" size="40"></input>'),modal.getRoot().on(_modal_events.default.save,(()=>{let result=document.querySelector("input[name='promptname']").value;modal.getRoot().remove(),callback(result)})),modal.show().then((()=>document.querySelector("input[name='promptname']").focus()));let defaultButton=modal.getRoot().find(".btn-primary");document.querySelector("input[name='promptname']").addEventListener("keyup",(function(event){event.preventDefault(),13===event.keyCode&&defaultButton.click()}))})).catch((error=>{console.error("error:",error),alert(error)}))}function modalConfirm(titleId,textId,callback,param){let stringsPromise;stringsPromise=param?Str.get_strings([{key:titleId,component:"qtype_proforma"},{key:textId,component:"qtype_proforma",param:param}]):Str.get_strings([{key:titleId,component:"qtype_proforma"},{key:textId,component:"qtype_proforma"}]);let modalPromise=_modal_factory.default.create({type:_modal_factory.default.types.SAVE_CANCEL});Promise.all([stringsPromise,modalPromise]).then((_ref3=>{let[strings,modal]=_ref3;modal.setTitle(strings[0]),modal.setSaveButtonText("Ok"),modal.setBody(strings[1]),modal.getRoot().on(_modal_events.default.save,(()=>{modal.getRoot().remove(),callback()})),modal.show()})).catch((error=>{console.error("error:",error),alert(error)}))}class TreeNode{constructor(name){this.name=name,this.element=void 0,this.parent=void 0,this.boundHandleContextMenu=event=>{event.preventDefault(),event.stopPropagation(),this.setContextMenu().then((()=>{if(void 0===this.getFramework().menu)return;(_ref4=>{let{top:top,left:left}=_ref4;this.getFramework().menu.style.left="".concat(left,"px"),this.getFramework().menu.style.top="".concat(top,"px"),this.getFramework().toggleContextmenu("show")})({left:event.pageX,top:event.pageY})}))},this.handleDragStart=event=>{0==event.dataTransfer.getData("treeitem").length&&event.dataTransfer.setData("treeitem",this.getPath())}}getPath(){return void 0===this.parent?this.name:this.parent.getPath()+"/"+this.name}setContextMenu(){return TreeNode.menu=void 0,Promise.resolve(null)}displayInTreeview(domnode){const li=document.createElement("li");return li.setAttribute("role","treeitem"),li.setAttribute("draggable","true"),domnode.appendChild(li),li.addEventListener("contextmenu",this.boundHandleContextMenu),li.addEventListener("dragstart",this.handleDragStart),this.element=li,li}getFramework(){return this.parent.getFramework()}async alreadyExists(name){!function(textId,param){let stringsPromise;stringsPromise=param?Str.get_strings([{key:"info"},{key:textId,component:"qtype_proforma",param:param}]):Str.get_strings([{key:"info"},{key:textId,component:"qtype_proforma"}]);let modalPromise=_modal_factory.default.create({type:_modal_factory.default.types.DEFAULT});Promise.all([stringsPromise,modalPromise]).then((_ref2=>{let[strings,modal]=_ref2;modal.setTitle(strings[0]),modal.setBody(strings[1]),modal.show()})).catch((error=>{console.error("error:",error),alert(error)}))}("alreadyexists",name)}}class FileNode extends TreeNode{static getEditorModeFromFilename(filename){switch(filename.split(".").pop().toLowerCase()){case"java":return"text/x-java";case"py":return"text/x-python";case"setlx":return"text/text";case"c":return"text/x-csrc";case"cpp":case"cxx":case"h":case"hpp":return"text/x-c++src";case"xml":return"application/xml";case"html":return"text/html";case"sql":return"text/x-sql";case"js":return"text/javascript";case"php":return"application/x-httpd-php";case"txt":case"log":case"md":case"csv":return"text"}}constructor(name){super(name),this.filecontent="",this.mode=FileNode.getEditorModeFromFilename(this.name),this.handleDelete=event=>{this.getFramework().handleClick(event);let context=this;modalConfirm("delete","deletefile",(function(){context.getFramework().deleteEditor(context),context.getFramework().syncer.deleteFileOrFolder(context.getPath()),context.element.remove(),context.parent.files=context.parent.files.filter((item=>item!==context))}),this.getPath())},this.boundHandleRename=event=>{this.getFramework().handleClick(event);let thecontext=this;modalPrompt("rename","enterfilename",thecontext.name,(name=>{if(null!==name&&name.length>0){if(!thecontext.parent.isNameChildUnique(name))return void thecontext.alreadyExists(name);const oldpath=thecontext.getPath();thecontext.name=name,thecontext.element.innerHTML=name;const newpath=thecontext.getPath();thecontext.mode=FileNode.getEditorModeFromFilename(thecontext.name),thecontext.getFramework().syncer.renameFile(oldpath,newpath),thecontext.getFramework().editorstack.update(thecontext)}}))},this.boundHandleClick=event=>{this.getFramework().toggleContextmenu("hide"),this.getFramework().setFocusTo(this.element),event.stopPropagation()},this.handleDoubleClick=event=>{this.getFramework().toggleContextmenu("hide"),null!=this.filecontent&&this.getFramework().switchEditorTo(this),this.getFramework().setFocusTo(this.element),event.stopPropagation()}}getContent(){if(0==this.filecontent.length){const p1=this.getFramework().syncer.download(this.getPath());return p1.then((result=>(this.filecontent=result,result))),p1}return Promise.resolve(this.filecontent)}updateContent(newcontent,async){return this.filecontent=newcontent,console.log("Update "+this.getPath()+" with "+newcontent.substr(0,20)+"..."),this.getFramework().syncer.update(this.getPath(),newcontent,async)}displayInTreeview(domnode){const li=super.displayInTreeview(domnode);li.innerHTML=this.name,li.classList.add("doc"),li.addEventListener("dblclick",this.handleDoubleClick),li.addEventListener("click",this.boundHandleClick)}setContextMenu(){console.log("FileNode setContextMenu");let thecontext=this;return Str.get_strings([{key:"delete",component:"qtype_proforma"},{key:"rename",component:"qtype_proforma"}]).done((function(strings){thecontext.getFramework().createContextMenu([[strings[0]+"...",thecontext.handleDelete],[strings[1]+"...",thecontext.boundHandleRename]])})).fail((function(response){console.error(response)}))}}_exports.FileNode=FileNode;class FolderNode extends TreeNode{constructor(name){super(name),this.files=[],this.folders=[],this.handleDelete=event=>{this.getFramework().handleClick(event);let context=this;modalConfirm("delete","deletefolder",(function(){context.getFramework().syncer.deleteFileOrFolder(context.getPath()+"/."),context.element.remove(),context.parent.folders=context.parent.folders.filter((item=>item!==context))}),this.getPath())},this.boundHandleNewFile=event=>{this.getFramework().handleClick(event);let thecontext=this;modalPrompt("newemptyfile","filename","",(filename=>{if(null!==filename&&filename.length>0){if(!thecontext.isNameChildUnique(filename))return void thecontext.alreadyExists(filename);let node=new FileNode(filename);thecontext.appendFile(node),node.displayInTreeview(thecontext.element.querySelector('[role="group"]')),thecontext.expand(!0),thecontext.getFramework().syncer.newfile(node.getPath()).then((()=>{thecontext.getFramework().addEditor(node),thecontext.getFramework().setFocusTo(node.element)}))}}))},this.boundHandleLoadFile=event=>{this.getFramework().handleClick(event);let input=document.createElement("input");input.type="file",input.onchange=e=>{let file=e.target.files[0];this._addFileFromOs(file,!0)},input.click()},this.handleDragOver=event=>{event.preventDefault()},this.handleDragEnter=()=>{this.getFramework().readOnly||this.element.querySelector(".name").classList.add("dragover")},this.handleDragLeave=()=>{this.getFramework().readOnly||this.element.querySelector(".name").classList.remove("dragover")},this.handleDrop=event=>{if(event.preventDefault(),event.stopPropagation(),this.getFramework().toggleContextmenu("hide"),this.getFramework().readOnly)return;this.element.querySelector(".name").classList.remove("dragover");const path=event.dataTransfer.getData("treeitem");if(void 0!==path&&path.length>0){console.log("drop "+path+" onto "+this.getPath());const node=this.getFramework().findNodeByPath(path);if(void 0!==node&&!this.isNameChildUnique(node.name))return void this.alreadyExists(node.name);if(node instanceof FolderNode){const oldpath=node.getPath();node.parent.folders=node.parent.folders.filter((item=>item!==node)),this.appendFolder(node),this.element.querySelector("ul").appendChild(node.element),this.expand(!0),this.getFramework().syncer.renameFolder(oldpath,node.getPath())}else if(node instanceof FileNode){const oldpath=node.getPath();node.parent.files=node.parent.files.filter((item=>item!==node)),this.appendFile(node),this.element.querySelector("ul").appendChild(node.element),this.expand(!0),this.getFramework().syncer.renameFile(oldpath,node.getPath())}else console.error("node cannot be moved"),console.log(node)}else{console.log("drop file/folder");let items=event.dataTransfer.items;for(let i=0;i<items.length;i++){let item=items[i].webkitGetAsEntry();item&&this._getFileTree(item)}}},this.boundHandleNewFolder=event=>{this.getFramework().handleClick(event);let thecontext=this;modalPrompt("newfolder","enterfoldername","",(foldername=>{if(null!==foldername&&foldername.length>0){if(!thecontext.isNameChildUnique(foldername))return void thecontext.alreadyExists(foldername);let node=new FolderNode(foldername);thecontext.appendFolder(node),node.displayInTreeview(thecontext.element.querySelector('[role="group"]')),thecontext.expand(!0),console.log("create new folder "+node.getPath()),thecontext.getFramework().syncer.mkdir(node.getPath())}}))},this.boundHandleClick=event=>{console.log("FolderNode click"),this.getFramework().toggleContextmenu("hide"),this.getFramework().setFocusTo(this.element),event.stopPropagation(),event.preventDefault()},this.boundHandleRename=event=>{this.getFramework().handleClick(event);let thecontext=this;modalPrompt("rename","enterfoldername",thecontext.name,(name=>{if(null!==name&&name.length>0){if(!thecontext.parent.isNameChildUnique(name))return void thecontext.alreadyExists(name);const oldpath=thecontext.getPath()+"/.";thecontext.name=name,thecontext.element.querySelector(".name").innerHTML=name;const newpath=thecontext.getPath()+"/.";thecontext.getFramework().syncer.renameFolder(oldpath,newpath)}}))},this.toggleExpand=()=>{this.element.setAttribute("aria-expanded",!this.isExpanded())},this.handleMouseOver=event=>{event.currentTarget.classList.add("hover")},this.handleMouseOut=event=>{event.currentTarget.classList.remove("hover")}}findNodeByPath(path){let first=path.shift();for(let i=0;i<this.files.length;i++)if(this.files[i].name===first)return this.files[i];for(let i=0;i<this.folders.length;i++)if(this.folders[i].name===first)return 0==path.length?this.folders[i]:this.folders[i].findNodeByPath(path)}createPath(path){let first=path.shift();if(void 0===first||0==first.length)return path.lenghth>0&&console.error("Bug in creating path"),this;for(let i=0;i<this.folders.length;i++)if(this.folders[i].name===first)return 0==path.length?this.folders[i]:this.folders[i].createPath(path);let node=new FolderNode(first);return this.appendFolder(node),node.createPath(path)}isNameChildUnique(name){for(let i=0;i<this.files.length;i++)if(0==name.localeCompare(this.files[i].name))return!1;for(let i=0;i<this.folders.length;i++)if(0==name.localeCompare(this.folders[i].name))return!1;return!0}_getFileTree(item){let path=arguments.length>1&&void 0!==arguments[1]?arguments[1]:void 0;const recurseinit=void 0===path;path=path||"",item.isFile?item.file((file=>{this._addFileFromOs(file,recurseinit)})):item.isDirectory}_addFileFromOs(file){let show=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(!this.isNameChildUnique(file.name))return void this.alreadyExists(file.name);let node=new FileNode(file.name),reader=new FileReader;reader.readAsText(file,"UTF-8"),reader.onload=readerEvent=>{let content=readerEvent.target.result;node.filecontent=content,show&&(this.getFramework().addEditor(node),this.getFramework().setFocusTo(node.element)),this.getFramework().syncer.upload(node.getPath(),file)},this.appendFile(node),node.displayInTreeview(this.element.querySelector('[role="group"]')),this.expand(!0)}expand(doit){this.element.setAttribute("aria-expanded",doit)}displayInTreeview(domnode){const li=super.displayInTreeview(domnode);li.setAttribute("aria-expanded","false");const span2=document.createElement("span");span2.addEventListener("dblclick",this.toggleExpand),span2.innerHTML=this.name,span2.classList.add("name"),span2.addEventListener("click",this.boundHandleClick),span2.addEventListener("dragenter",this.handleDragEnter),span2.addEventListener("dragleave",this.handleDragLeave),span2.addEventListener("drop",this.handleDrop),span2.addEventListener("dragover",this.handleDragOver),li.appendChild(span2);const subul=document.createElement("ul");subul.setAttribute("role","group"),li.appendChild(subul);for(let j=0;j<this.folders.length;j++)this.folders[j].displayInTreeview(subul);for(let j=0;j<this.files.length;j++)this.files[j].displayInTreeview(subul)}isExpanded(){return"true"===this.element.getAttribute("aria-expanded")}setContextMenu(){console.log("FolderNode setContextMenu");let thecontext=this;return Str.get_strings([{key:"newemptyfile",component:"qtype_proforma"},{key:"loadfile",component:"qtype_proforma"},{key:"newfolder",component:"qtype_proforma"},{key:"rename",component:"qtype_proforma"},{key:"delete",component:"qtype_proforma"}]).done((function(strings){thecontext.getFramework().createContextMenu([[strings[0]+"...",thecontext.boundHandleNewFile],[strings[1]+"...",thecontext.boundHandleLoadFile],[strings[3]+"...",thecontext.boundHandleRename],[strings[4]+"...",thecontext.handleDelete]])})).fail((function(response){console.error(response)}))}appendFile(node){this.files.push(node),node.parent=this}appendFolder(node){this.folders.push(node),node.parent=this}}_exports.FolderNode=FolderNode;class RootNode extends FolderNode{constructor(name,framework){super(name),console.log("CREATE root node "+name),this.framework=framework,framework.roots.push(this)}getFramework(){return this.framework}getPath(){return""}setContextMenu(){console.log("RootNode setContextMenu");let thecontext=this;return Str.get_strings([{key:"newemptyfile",component:"qtype_proforma"},{key:"loadfile",component:"qtype_proforma"},{key:"newfolder",component:"qtype_proforma"}]).done((function(strings){thecontext.getFramework().createContextMenu([[strings[0]+"...",thecontext.boundHandleNewFile],[strings[1]+"...",thecontext.boundHandleLoadFile]])})).fail((function(response){console.error(response)}))}}_exports.RootNode=RootNode;class EditorItem{constructor(fileNode,textarea,tabDomNode,readOnly){console.log("Create Codemirror "+readOnly),this.fileNode=fileNode,this.editor=_codemirror.default.fromTextArea(textarea,{tabMode:"indent",indentUnit:4,matchBrackets:!0,autoCloseBrackets:!0,styleActiveLine:!0,readOnly:readOnly,extraKeys:{Tab:function(){this.editor.replaceSelection("    ","end")}},lineNumbers:!0}),this.editor.setSize("100%","100%"),this.editor.setOption("theme","darcula"),this.tab=tabDomNode}}class EditorStack{constructor(donNodeEditor,donNodeTabs,framework){this.editortextarea=donNodeEditor.querySelector("textarea"),this.editor=_codemirror.default.fromTextArea(this.editortextarea,{tabMode:"indent",indentUnit:4,matchBrackets:!0,autoCloseBrackets:!0,styleActiveLine:!0,readOnly:!0,extraKeys:{Tab:function(){this.editor.replaceSelection("    ","end")}},lineNumbers:!0}),this.editor.setSize("100%","100%"),this.editor.setOption("theme","darcula"),this.activeNode=void 0,this.nodes=[],this.donNodeTabs=donNodeTabs,this.focus=void 0,this.framework=framework}cleanup(){this.timer&&clearInterval(this.timer)}_switchTo(item){let index=arguments.length>1&&void 0!==arguments[1]?arguments[1]:void 0;if(this.saveCurrentEditor(!0),void 0===index)for(index=0;index<this.nodes.length&&this.nodes[index]!==item;index++);for(console.log("item index is "+index),this.nodes.splice(index,1),this.nodes.push(item),index=0;index<this.nodes.length;index++)this.nodes[index].editor.getWrapperElement().style.display="none";if(item.editor.getWrapperElement().style.display="block",item.editor.refresh(),item.editor.focus(),void 0!==this.focus){this.focus.classList.remove("focus"),this.focus.querySelector(".close").style.display="none"}item.tab.classList.add("focus"),item.tab.querySelector(".close").style.display="inline",this.focus=item.tab}_delete(item){for(let i=0;i<this.nodes.length;i++)if(this.nodes[i]===item)return console.log("** Delete item from editor"),this.nodes[i].fileNode.updateContent(this.nodes[i].editor.getValue()),this.nodes.splice(i,1),item.editor.getWrapperElement().remove(),void(this.nodes.length>0&&this._switchTo(this.nodes[this.nodes.length-1],this.nodes.length-1));console.error("could not find filenode")}deleteEditor(filenode){for(let i=0;i<this.nodes.length;i++)if(this.nodes[i].fileNode===filenode)return this.nodes[i].tab.remove(),this.nodes[i].tab=void 0,void this._delete(this.nodes[i])}addEditor(filenode){if(EditorStack.maxEditors===this.nodes.length)return void alert("maximum number of editors reached");let tab=document.createElement("button"),item=new EditorItem(filenode,this.editortextarea,tab,this.framework.readOnly);filenode.getContent().then((text=>{void 0===text&&(text="???"),item.editor.setValue(text),void 0!==filenode.mode&&item.editor.setOption("mode",filenode.mode),item.editor.refresh()})).catch((error=>{console.error("error:",error),alert(error)})),tab.classList.add("tab");let close=document.createElement("span");close.classList.add("close"),close.innerHTML="&#x2715",close.addEventListener("click",(event=>{event.preventDefault(),event.stopPropagation(),this._delete(item),close.parentElement.remove()})),tab.innerHTML=filenode.name,tab.append(close),tab.addEventListener("click",(event=>{event.preventDefault(),event.stopPropagation(),this._switchTo(item)})),this.donNodeTabs.append(tab),this.nodes.push(item),this._switchTo(item)}update(filenode){for(let i=0;i<this.nodes.length;i++)if(this.nodes[i].fileNode===filenode)return this.nodes[i].tab.innerHTML=filenode.name,void(void 0!==filenode.mode&&this.nodes[i].editor.setOption("mode",filenode.mode))}switchEditorTo(filenode){for(let i=0;i<this.nodes.length;i++)if(this.nodes[i].fileNode===filenode)return void this._switchTo(this.nodes[i],i);this.addEditor(filenode),this.timer&&clearInterval(this.timer);let that=this;autosaveIntervall>0&&(this.timer=setInterval((function(){console.log("proforma editor autosave"),that.saveCurrentEditor(!0)}),autosaveIntervall))}saveCurrentEditor(async){let currentNode=this._getCurrentNode();if(currentNode){const text=currentNode.editor.getValue();text.length>0&&currentNode.fileNode.updateContent(text,async)}}_getCurrentNode(){return this.nodes.length>0?this.nodes[this.nodes.length-1]:null}handleResize(){this.nodes.length>0&&this.nodes[this.nodes.length-1].editor.refresh()}save(){console.log("currently open editors "+this.nodes.length.toString()),console.timeStamp("save"),console.time("save");for(let i=0;i<this.nodes.length;i++)this.nodes[i].fileNode.updateContent(this.nodes[i].editor.getValue(),!1);console.log("all files saved"),console.timeStamp("save"),console.timeEnd("save")}}_defineProperty(EditorStack,"maxEditors",12);_exports.Framework=class{constructor(){_defineProperty(this,"toggleContextmenu",(command=>{void 0!==this.menu&&(this.menu.style.display="show"===command?"block":"none",this.menuVisible="show"===command)})),this.roots=[],this.syncer=void 0,this.editorstack=void 0,this.mainDomNode=void 0,this.menu=void 0,this.menuVisible=!1,this.focus=void 0,this.readOnly=!1,this.rootnode="Submission"}buildFramework(domnode){console.log("buildFramework"),domnode.innerHTML='<div class="ide" style="display: flex;flex-direction: column; align-items: stretch;\n    resize: vertical;\n    overflow: hidden;\n    min-height: 150px">\n    \x3c!--<div class="menu" style="flex: none">menu</div>--\x3e\n\n    <div class="body" style="display: flex; flex-direction: row; flex: 1 1 0; min-height: 0">\n        \x3c!--<div class="fake" style="min-width: 100px; flex: 1 0 0; overflow: auto;">Fake element</div> --\x3e\n        <div class="explorer" style="min-width: 20px; flex: 1 0 0; overflow: auto;">\n        </div>\n        <div class="resize"></div>\n        <div class="canvas" style="min-width: 20px;  flex: 0 0 75%; display: flex; flex-direction: row;">\n            \x3c!-- set flex-basis = 50% for 2 two columns and 100%V for one column --\x3e\n            <div class="canvascol" style="display: flex; flex-direction: column; flex: 1 1 50%; overflow: hidden;">\n                <div class="tabs" style="flex: none; ">\n                </div>\n                <div class="editor" style="flex: 1 1 0; overflow: hidden;">\n                    <textarea></textarea>\n                </div>\n            </div>\n            \x3c!--\n            <div class="resize"></div>\n            <div class="canvascol" style="display: flex; flex-direction: column; flex: 1 1 50%; min-height: 0;">\n                <div class="tabs" style="flex: none; ">\n                </div>\n                <div class="editor" style="flex: 1 1 0; min-height: 0; overflow: hidden;">\n                    <textarea></textarea>\n                </div>\n            </div> --\x3e \n        </div>\n    </div>\n\n    \x3c!--<div class="status" style="flex: none">status</div>--\x3e\n</div>\n<p>\x3c!--<label>File or Folder Selected: <input id="last_action" type="text" size="15" readonly=""></label>--\x3e</p>\n';const menu=document.createElement("div");menu.innerHTML='<div class="contextmenu" id="context-menu">\n    <ul class="menu-options">\n        <li class="menu-option">New file</li>\n        <li class="menu-option">New folder</li>\n        <li class="menu-option">Delete...</li>\n    </ul>\n</div>',document.querySelector("body").appendChild(menu),this.mainDomNode=domnode,this.editorstack=new EditorStack(domnode.querySelector(".editor"),domnode.querySelector(".tabs"),this)}init(node,syncer,readOnly,options){this.readOnly=readOnly,this.rootnode=options.rootnode,autosaveIntervall=void 0!==options.explorerautosave&&options.explorerautosave>0?1e3*options.explorerautosave:-1;const fileviewer=node.querySelector(".explorer");fileviewer.addEventListener("drop",(event=>{event.preventDefault()})),fileviewer.addEventListener("dragover",(event=>{event.preventDefault()}));let ul=document.createElement("ul");ul.setAttribute("role","tree"),ul.setAttribute("aria-labelledby","fileviewer"),fileviewer.appendChild(ul),this.syncer=syncer,this.createPath("/"),this.syncer.list(this).then((()=>{console.log("DISPLAY ROOTS"),console.log(this.roots);for(let i=0;i<this.roots.length;i++){let root=this.roots[i];root.displayInTreeview(ul),root.toggleExpand()}})),window.addEventListener("click",(e=>{this.handleClick()}));let el=this.mainDomNode.querySelector(".ide");new ResizeObserver((()=>{this.editorstack.handleResize()})).observe(el),(resizer=>{const before=resizer.previousElementSibling,after=resizer.nextElementSibling;let x=0,oldValue=0,mousedown=!1;const removeSelection=()=>{resizer.style.removeProperty("cursor"),document.body.style.removeProperty("cursor"),before.style.removeProperty("user-select"),before.style.removeProperty("pointer-events"),null!=after&&(after.style.removeProperty("user-select"),after.style.removeProperty("pointer-events"))},mouseMoveHandler=e=>{if(mousedown){const dx=e.clientX-x;let newBasis=100*(oldValue+dx)/resizer.parentNode.getBoundingClientRect().width;before.style.flexBasis="".concat(newBasis,"%"),null!=after?after.style.flexBasis="".concat(100-newBasis,"%"):resizer.parentNode.getBoundingClientRect().width=resizer.parentNode.getBoundingClientRect().width-dx,removeSelection()}else mouseUpHandler()},mouseUpHandler=function(){removeSelection(),document.removeEventListener("mousemove",mouseMoveHandler),document.removeEventListener("mouseup",mouseUpHandler)};resizer.addEventListener("mousedown",(e=>{x=e.clientX,this.toggleContextmenu("hide"),oldValue=before.getBoundingClientRect().width,mousedown=!0,document.addEventListener("mousemove",mouseMoveHandler),document.addEventListener("mouseup",mouseUpHandler),removeSelection()}))})(node.querySelector(".ide .body > .resize"))}switchEditorTo(filenode){this.editorstack.switchEditorTo(filenode)}addEditor(filenode){this.editorstack.switchEditorTo(filenode)}deleteEditor(filenode){this.editorstack.deleteEditor(filenode)}findNodeByPath(path){if(console.log("find <"+path+">"),"/"!=path.substr(0,1))return void console.error("path does not start with /: "+path);let pathsplit=path.split("/");return pathsplit.shift(),this.roots[0].findNodeByPath(pathsplit)}createPath(path){console.log("Framework: create folder "+path),"/"!==path[0]&&console.error("first char in path is not /: "+path);let root,pathsplit=path.split("/");pathsplit.shift();let context=this;return 0===this.roots.length?(root=new RootNode(context.rootnode,context),root.createPath(pathsplit)):(root=this.roots[0],root.createPath(pathsplit))}createContextMenu(list){if(this.readOnly)return;console.log("createContextMenu "+list.length);let ul=document.querySelector(".contextmenu .menu-options");ul.innerHTML="";for(let i=0;i<list.length;i++){const li=document.createElement("li");li.setAttribute("class","menu-option"),li.innerHTML=list[i][0],li.addEventListener("click",list[i][1]),console.log(list[i][0]),ul.appendChild(li)}this.menu=ul.parentNode}handleClick(){this.toggleContextmenu("hide"),this.setFocusTo(void 0)}setFocusTo(element){void 0!==this.focus&&this.focus.classList.remove("focus"),void 0!==element?(element.classList.add("focus"),this.focus=element):this.focus=void 0}save(){return console.log(this),console.log(this.editorstack),this.editorstack.save()}}}));

//# sourceMappingURL=FileViewer.min.js.map